<bugID>471802<Summary>Location bar identity display ignores certified CN, always showing hostname or eTLD+1 depending on browser.identity.ssl_domain_display</Summary><Description>User-Agent:       Mozilla/5.0 (Windows; U; Windows NT 5.0; de; rv:1.9.1b1) Gecko/20081007 Firefox/3.1b1
Build Identifier: 

When the location bar is set to show the SSL Identity Name by setting browser.identity.ssl_domain_display to 2 in about:config the Location Bar always shows the hostname part of the domain visited, instead of the Common Name the certificate is signed for.

In case of the URL https://bugzilla.mozilla.org/ the associated SSL cert is signed for Common Name CN=*.mozilla.org, but the additional Identity Field shows bugzilla.mozilla.org.

This can be abused by attackers by generating domain names quite simular to the original name of the domain you browsed to and presenting a certificate that certifies a shorter version of the Domain name (e.g. get a cert for *.org instead of *.mozilla.org). An enduser could not easily distinguish the legitimate cert from the fake one since in both cases he is presented the full bugzilla.mozilla.org domain name as being signed.

Reproducible: Always

Steps to Reproduce:
1. Set browser.identity.ssl_domain_display to 2 in about:config
2. Open up a SSL encrypted domain with a wildcard cert (e.g. bugzilla.mozilla.org

Actual Results:  
The Location Bar shows "bugzilla.mozilla.org"

Expected Results:  
The Location Bar shows the signed Common Name of the certificate (in this case *.mozilla.org)

Happy reading of the latest Certificate talks at:
https://blog.startcom.org/?p=145
https://events.ccc.de/2008/12/30/the-cat-is-out-of-the-bag/</Description></bugID>